org.apache.commons.io.input

## Class ReadAheadInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.io.input.ReadAheadInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class ReadAheadInputStream
      extends InputStream

  Implements `InputStream` to asynchronously read ahead from an underlying input stream when a specified amount of data has been read from the current buffer. It does so by maintaining two buffers: an active buffer and a read ahead buffer. The active buffer contains data which should be returned when a read() call is issued. The read ahead buffer is used to asynchronously read from the underlying input stream. When the current active buffer is exhausted, we flip the two buffers so that we can start reading from the read ahead buffer without being blocked by disk I/O.

  This class was ported and adapted from Apache Spark commit 933dc6cb7b3de1d8ccaf73d124d6eb95b947ed19.

  Since:
    2.9.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReadAheadInputStream(InputStream inputStream, int bufferSizeInBytes)` Creates an instance with the specified buffer size and read-ahead threshold
    `ReadAheadInputStream(InputStream inputStream, int bufferSizeInBytes, ExecutorService executorService)` Creates an instance with the specified buffer size and read-ahead threshold

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()`
    `void` | `close()`
    `int` | `read()`
    `int` | `read(byte[] b, int offset, int len)`
    `long` | `skip(long n)`

    - ### Methods inherited from class java.io.InputStream

      `mark, markSupported, read, reset`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ReadAheadInputStream

          public ReadAheadInputStream(InputStream inputStream,
                                      int bufferSizeInBytes)

      Creates an instance with the specified buffer size and read-ahead threshold
      Parameters:
        `inputStream` - The underlying input stream.
        `bufferSizeInBytes` - The buffer size.

    - #### ReadAheadInputStream

          public ReadAheadInputStream(InputStream inputStream,
                                      int bufferSizeInBytes,
                                      ExecutorService executorService)

      Creates an instance with the specified buffer size and read-ahead threshold
      Parameters:
        `inputStream` - The underlying input stream.
        `bufferSizeInBytes` - The buffer size.
        `executorService` - An executor service for the read-ahead thread.

  - ### Method Detail

    - #### available

          public int available()
                        throws IOException

      Overrides:
        `available` in class `InputStream`
      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `InputStream`
      Throws:
        `IOException`

    - #### read

          public int read()
                   throws IOException

      Specified by:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### read

          public int read(byte[] b,
                          int offset,
                          int len)
                   throws IOException

      Overrides:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### skip

          public long skip(long n)
                    throws IOException

      Overrides:
        `skip` in class `InputStream`
      Throws:
        `IOException`

Copyright © 2002–2021 The Apache Software Foundation. All rights reserved.